﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GasolineTanker
{
    internal static class ExtentionGasolineTanker
    {
        private static readonly char _separatorForObject = ':';

        public static DrawingGasolineTanker CreateDrawingGasolineTanker(this string info)
        {
            string[] strs = info.Split(_separatorForObject);
            if (strs.Length == 3)
            {
                return new DrawingGasolineTanker(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
            }
            if (strs.Length == 6)
            {
                return new DrawingImprovedGasolineTanker(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                Color.FromName(strs[3]), Convert.ToBoolean(strs[4]),
                Convert.ToBoolean(strs[5]));
            }
            return null;
        }
        public static string GetDataForSave(this DrawingGasolineTanker drawingGasolineTanker)
        {
            var GasolineTanker = drawingGasolineTanker.GasolineTanker;
            var str = $"{GasolineTanker.Speed}{_separatorForObject}{GasolineTanker.Weight}{_separatorForObject}{GasolineTanker.BodyColor.Name}";
            if (GasolineTanker is not EntityImprovedGasolineTanker improvedGasolineTanker)
            {
                return str;
            }
            return $"{str}{_separatorForObject}{improvedGasolineTanker.DopColor.Name}{_separatorForObject}{improvedGasolineTanker.BodyKit}{_separatorForObject}{improvedGasolineTanker.OrnamentWheels}";
        }
    }
}
